//+------------------------------------------------------------------+
//|                                                Open_position.mq4 |
//|                                                        Blowysoft |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Blowysoft"
#property link      ""
#property show_inputs
#include <stdlib.mqh>
#include <WinUser32.mqh>
#include <Money_mgmnt.mqh>

  extern double   Risk           = 2;
  extern int      MAGIC          = 323232;
  
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
  

  double riskratio      = 0;
  double Lots           = 0;
  int    Stopsize       = 0;
  double Stopprice      = 0;
  int    Ticket         = 0;
  
  double Pips = Point;
  if(Digits==3 || Digits==5)Pips=10*Point;
  
//----

   if(MessageBox("Do you want to execute a trade?", "Open Position", MB_YESNO|MB_ICONWARNING) == IDYES) 
      {
         //Draw stop loss line, and ask user to position it.
         if(ObjectFind("Stop-Loss") == -1)
         {
            ObjectCreate("Stop-Loss",OBJ_HLINE,0,0,0);
            ObjectSet("Stop-Loss",OBJPROP_COLOR,Red);
            ObjectSet("Stop-Loss",OBJPROP_STYLE, STYLE_SOLID);
            ObjectSet("Stop-Loss",OBJPROP_WIDTH,2);
         }
         ObjectSet("Stop-Loss",OBJPROP_PRICE1, Bid + 10*Pips);
         
         if(MessageBox("Move Stop Loss line to desired level and press OK to enter trade.","Execute Trade",MB_OKCANCEL|MB_ICONWARNING)== IDOK)
            {
               Stopprice=ObjectGet("Stop-Loss",OBJPROP_PRICE1);
               if(Stopprice > Bid + MarketInfo(Symbol(),MODE_FREEZELEVEL))
                  {
                  Stopsize=(Stopprice - Bid)/Pips;
                  Lots=Get_Lot_Size(Stopsize,Risk,AccountBalance(),true);
                  if(Lots>0) Ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,0,"Opened position at "+NormalizeDouble(Risk,2)+"%",MAGIC,0,CLR_NONE);
                  if(Ticket == -1)
                     {
                     MessageBox("Error opening trade Code :"+GetLastError(),"Error!",MB_OK);
                     Print("Error opening short trade: Lots: ",Lots," Price: ",Bid," Slippage: ",3," No TP or SL");
                     return(0);  
                     }
                  OrderModify(Ticket,OrderOpenPrice(),Stopprice,OrderTakeProfit(),0,CLR_NONE);
                  MessageBox("Trade opened with Ticket number "+Ticket,MB_OK);
                  }
               else if(Stopprice < Ask - MarketInfo(Symbol(),MODE_FREEZELEVEL))
                  {
                  Stopsize=(Ask - Stopprice)/Pips;
                  Lots=Get_Lot_Size(Stopsize,Risk,AccountBalance(),true);
                  if(Lots>0) Ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,0,"Opened position at "+NormalizeDouble(Risk,2)+"%",MAGIC,0,CLR_NONE);
                  if(Ticket == -1)
                     {
                     MessageBox("Error opening trade Code :"+GetLastError(),"Error!",MB_OK);
                     Print("Error opening long trade: Lots: ",Lots," Price: ",Bid," Slippage: ",3," No TP or SL");
                     return(0);  
                     }
                  OrderModify(Ticket,OrderOpenPrice(),Stopprice,OrderTakeProfit(),0,CLR_NONE);
                  MessageBox("Trade opened with Ticket number "+Ticket,MB_OK);
                  }
               else
               {
                  MessageBox("Invalid Stop-Loss!! Trade operation Cancelled",MB_OK);
                  return(1);
               }
            }
         else MessageBox("Trade operation cancelled!",MB_OK);
      }
   //else Comment("You pressed No!");
//----
   if(ObjectFind("Stop-Loss") == 1)ObjectDelete("Stop-Loss");
   return(0);
  }
//+------------------------------------------------------------------+